#include "orxonox_gui_video.h"

void video_option_change(GtkWidget *widget, int* data)
{
  *data = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)); 
  orxonox_flags_update ();
  if (verbose >=1)
    printf ("%s changed to %i.\n", gtk_button_get_label(GTK_BUTTON(widget)), *data);
}

/* Drawing The VIDEO_FRAME */
GtkWidget *orxonox_gui_video_frame (struct settings *orxonox_settings)
{
  GtkWidget *frame;
  GtkWidget *fullscreen_button;
  GtkWidget *wireframe_button;
  
  frame = gtk_frame_new ( "Video-Options:");
  gtk_container_set_border_width (GTK_CONTAINER (frame), 5);

  {
    GtkWidget *orxonox_gui_video_vbox;
    orxonox_gui_video_vbox = gtk_vbox_new (FALSE, 0);
    {
	fullscreen_button = gtk_check_button_new_with_label ("Fullscreen-mode");
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON (fullscreen_button), orxonox_settings->video_fullscreen);
	g_signal_connect(GTK_TOGGLE_BUTTON(fullscreen_button), "clicked", G_CALLBACK(video_option_change), &(orxonox_settings->video_fullscreen));
	gtk_box_pack_start(GTK_BOX (orxonox_gui_video_vbox), fullscreen_button, TRUE, TRUE, 0);

	wireframe_button = gtk_check_button_new_with_label ("Wireframe-mode");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (wireframe_button), orxonox_settings->video_wireframe);
	g_signal_connect(GTK_TOGGLE_BUTTON(wireframe_button), "clicked", G_CALLBACK(video_option_change), &(orxonox_settings->video_wireframe));
	gtk_box_pack_start(GTK_BOX (orxonox_gui_video_vbox), wireframe_button, TRUE, TRUE, 0);
	
    }
    gtk_container_add(GTK_CONTAINER(frame), orxonox_gui_video_vbox);
  }

  return frame;

}

